Index: /trunk/sources/HeuristicLab.Visualization.Test/3.2/LineChartTests.cs
===================================================================
--- /trunk/sources/HeuristicLab.Visualization.Test/3.2/LineChartTests.cs	(revision 1971)
+++ /trunk/sources/HeuristicLab.Visualization.Test/3.2/LineChartTests.cs	(revision 1972)
@@ -34,7 +34,7 @@
       row3.RowSettings.Label = "Maxi";
 
-      row1.Style = DrawingStyle.Solid;
-      row2.Style = DrawingStyle.Solid;
-      row3.Style = DrawingStyle.Dashed;
+      row1.RowSettings.Style = DrawingStyle.Solid;
+      row2.RowSettings.Style = DrawingStyle.Solid;
+      row3.RowSettings.Style = DrawingStyle.Dashed;
 
 
@@ -100,15 +100,15 @@
       row1.RowSettings.Color = Color.Red;
       row1.RowSettings.Thickness = 3;
-      row1.Style = DrawingStyle.Solid;
+      row1.RowSettings.Style = DrawingStyle.Solid;
       row1.RowSettings.Label = "Die Rote";
 
       row2.RowSettings.Color = Color.Green;
       row2.RowSettings.Thickness = 3;
-      row2.Style = DrawingStyle.Solid;
+      row2.RowSettings.Style = DrawingStyle.Solid;
       row2.RowSettings.Label = "Die Grüne";
 
       row3.RowSettings.Color = Color.Blue;
       row3.RowSettings.Thickness = 3;
-      row3.Style = DrawingStyle.Solid;
+      row3.RowSettings.Style = DrawingStyle.Solid;
       row3.RowSettings.Label = "Die Blaue";
       row3.YAxis = yaxis2;
@@ -143,5 +143,5 @@
       row1.RowSettings.Color = Color.Red;
       row1.RowSettings.Thickness = 3;
-      row1.Style = DrawingStyle.Solid;
+      row1.RowSettings.Style = DrawingStyle.Solid;
 
       model.AddDataRow(row1);
@@ -152,6 +152,6 @@
       aggregator.RowSettings.Color = Color.Pink;
       aggregator.RowSettings.Thickness = 5;
-      aggregator.Style = DrawingStyle.Solid;
-      aggregator.LineType = DataRowType.SingleValue;
+      aggregator.RowSettings.Style = DrawingStyle.Solid;
+      aggregator.RowSettings.LineType = DataRowType.SingleValue;
       aggregator.AddWatch(row1);
 
@@ -182,6 +182,6 @@
         row1.RowSettings.Thickness = 2;
         row1.RowSettings.Label = "Sinus";
-        row1.Style = DrawingStyle.Solid;
-        row1.ShowMarkers = false;
+        row1.RowSettings.Style = DrawingStyle.Solid;
+        row1.RowSettings.ShowMarkers = false;
         model.AddDataRow(row1);
 
@@ -190,6 +190,6 @@
         row2.RowSettings.Thickness = 3;
         row2.RowSettings.Label = "Growing";
-        row2.Style = DrawingStyle.Solid;
-        row2.ShowMarkers = false;
+        row2.RowSettings.Style = DrawingStyle.Solid;
+        row2.RowSettings.ShowMarkers = false;
         model.AddDataRow(row2);
 
@@ -198,7 +198,7 @@
         multiAvgAggregator.RowSettings.Color = Color.DarkOliveGreen;
         multiAvgAggregator.RowSettings.Thickness = 3;
-        multiAvgAggregator.Style = DrawingStyle.Solid;
-        multiAvgAggregator.LineType = DataRowType.SingleValue;
-        multiAvgAggregator.ShowMarkers = false;
+        multiAvgAggregator.RowSettings.Style = DrawingStyle.Solid;
+        multiAvgAggregator.RowSettings.LineType = DataRowType.SingleValue;
+        multiAvgAggregator.RowSettings.ShowMarkers = false;
         multiAvgAggregator.AddWatch(row1);
         multiAvgAggregator.AddWatch(row2);
@@ -209,7 +209,7 @@
         multiMaxAggregator.RowSettings.Color = Color.DarkKhaki;
         multiMaxAggregator.RowSettings.Thickness = 3;
-        multiMaxAggregator.Style = DrawingStyle.Solid;
-        multiMaxAggregator.LineType = DataRowType.SingleValue;
-        multiMaxAggregator.ShowMarkers = false;
+        multiMaxAggregator.RowSettings.Style = DrawingStyle.Solid;
+        multiMaxAggregator.RowSettings.LineType = DataRowType.SingleValue;
+        multiMaxAggregator.RowSettings.ShowMarkers = false;
         multiMaxAggregator.AddWatch(row1);
         multiMaxAggregator.AddWatch(row2);
@@ -220,7 +220,7 @@
         multiMinAggregator.RowSettings.Color = Color.DarkRed;
         multiMinAggregator.RowSettings.Thickness = 3;
-        multiMinAggregator.Style = DrawingStyle.Solid;
-        multiMinAggregator.LineType = DataRowType.SingleValue;
-        multiMinAggregator.ShowMarkers = false;
+        multiMinAggregator.RowSettings.Style = DrawingStyle.Solid;
+        multiMinAggregator.RowSettings.LineType = DataRowType.SingleValue;
+        multiMinAggregator.RowSettings.ShowMarkers = false;
         multiMinAggregator.AddWatch(row1);
         multiMinAggregator.AddWatch(row2);
@@ -260,6 +260,6 @@
         row1.RowSettings.Thickness = 2;
         row1.RowSettings.Label = "Sinus";
-        row1.Style = DrawingStyle.Solid;
-        row1.ShowMarkers = false;
+        row1.RowSettings.Style = DrawingStyle.Solid;
+        row1.RowSettings.ShowMarkers = false;
         model.AddDataRow(row1);
 
@@ -268,6 +268,6 @@
         row2.RowSettings.Thickness = 3;
         row2.RowSettings.Label = "Growing";
-        row2.Style = DrawingStyle.Solid;
-        row2.ShowMarkers = false;
+        row2.RowSettings.Style = DrawingStyle.Solid;
+        row2.RowSettings.ShowMarkers = false;
         model.AddDataRow(row2);
 
@@ -276,6 +276,6 @@
         aggregator.RowSettings.Color = Color.Pink;
         aggregator.RowSettings.Thickness = 3;
-        aggregator.Style = DrawingStyle.Solid;
-        aggregator.LineType = DataRowType.SingleValue;
+        aggregator.RowSettings.Style = DrawingStyle.Solid;
+        aggregator.RowSettings.LineType = DataRowType.SingleValue;
         aggregator.AddWatch(row1);
         model.AddDataRow(aggregator);
@@ -285,6 +285,6 @@
         maxAggregator.RowSettings.Color = Color.DeepSkyBlue;
         maxAggregator.RowSettings.Thickness = 3;
-        maxAggregator.Style = DrawingStyle.Solid;
-        maxAggregator.LineType = DataRowType.SingleValue;
+        maxAggregator.RowSettings.Style = DrawingStyle.Solid;
+        maxAggregator.RowSettings.LineType = DataRowType.SingleValue;
         maxAggregator.AddWatch(row1);
         model.AddDataRow(maxAggregator);
@@ -294,6 +294,6 @@
         avgAggregator.RowSettings.Color = Color.Violet;
         avgAggregator.RowSettings.Thickness = 3;
-        avgAggregator.Style = DrawingStyle.Solid;
-        avgAggregator.LineType = DataRowType.SingleValue;
+        avgAggregator.RowSettings.Style = DrawingStyle.Solid;
+        avgAggregator.RowSettings.LineType = DataRowType.SingleValue;
         avgAggregator.AddWatch(row1);
         model.AddDataRow(avgAggregator);
@@ -319,6 +319,6 @@
         row1.RowSettings.Thickness = 2;
         row1.RowSettings.Label = "Sinus";
-        row1.Style = DrawingStyle.Solid;
-        row1.ShowMarkers = false;
+        row1.RowSettings.Style = DrawingStyle.Solid;
+        row1.RowSettings.ShowMarkers = false;
         model.AddDataRow(row1);
 
@@ -327,6 +327,6 @@
         row2.RowSettings.Thickness = 3;
         row2.RowSettings.Label = "Growing";
-        row2.Style = DrawingStyle.Solid;
-        row2.ShowMarkers = false;
+        row2.RowSettings.Style = DrawingStyle.Solid;
+        row2.RowSettings.ShowMarkers = false;
         model.AddDataRow(row2);
 
@@ -335,7 +335,7 @@
         avgLineAggregator.RowSettings.Color = Color.Violet;
         avgLineAggregator.RowSettings.Thickness = 3;
-        avgLineAggregator.Style = DrawingStyle.Solid;
-        avgLineAggregator.LineType = DataRowType.Normal;
-        avgLineAggregator.ShowMarkers = false;
+        avgLineAggregator.RowSettings.Style = DrawingStyle.Solid;
+        avgLineAggregator.RowSettings.LineType = DataRowType.Normal;
+        avgLineAggregator.RowSettings.ShowMarkers = false;
         avgLineAggregator.AddWatch(row1);
         avgLineAggregator.AddWatch(row2);
@@ -361,6 +361,6 @@
         row1.RowSettings.Thickness = 2;
         row1.RowSettings.Label = "SinusHacked";
-        row1.Style = DrawingStyle.Solid;
-        row1.ShowMarkers = false;
+        row1.RowSettings.Style = DrawingStyle.Solid;
+        row1.RowSettings.ShowMarkers = false;
         model.AddDataRow(row1);
 
@@ -369,6 +369,6 @@
         row2.RowSettings.Thickness = 3;
         row2.RowSettings.Label = "GrowingHacked";
-        row2.Style = DrawingStyle.Solid;
-        row2.ShowMarkers = false;
+        row2.RowSettings.Style = DrawingStyle.Solid;
+        row2.RowSettings.ShowMarkers = false;
         model.AddDataRow(row2);
 
@@ -377,6 +377,6 @@
         avgAggregator.RowSettings.Label = "floatingAvg";
         avgAggregator.RowSettings.Color = Color.Peru;
-        avgAggregator.ShowMarkers = false;
-        avgAggregator.Style = DrawingStyle.Solid;
+        avgAggregator.RowSettings.ShowMarkers = false;
+        avgAggregator.RowSettings.Style = DrawingStyle.Solid;
 
         avgAggregator.AddWatch(row1);
@@ -387,6 +387,6 @@
         avgAggregator2.RowSettings.Label = "floatingAvg";
         avgAggregator2.RowSettings.Color = Color.Aqua;
-        avgAggregator2.ShowMarkers = false;
-        avgAggregator2.Style = DrawingStyle.Solid;
+        avgAggregator2.RowSettings.ShowMarkers = false;
+        avgAggregator2.RowSettings.Style = DrawingStyle.Solid;
 
         avgAggregator2.AddWatch(row2);
@@ -491,5 +491,5 @@
       row1.RowSettings.Color = Color.Red;
       row1.RowSettings.Thickness = 3;
-      row1.Style = DrawingStyle.Solid;
+      row1.RowSettings.Style = DrawingStyle.Solid;
 
       model.AddDataRow(row1);
@@ -543,14 +543,14 @@
       row6.RowSettings.Label = "anyways";
 
-      row1.Style = DrawingStyle.Solid;
-      row2.Style = DrawingStyle.Solid;
-      row3.Style = DrawingStyle.Dashed;
-
-      row4.Style = DrawingStyle.Solid;
-      row5.Style = DrawingStyle.Solid;
-      row6.Style = DrawingStyle.Dashed;
-
-      row1.LineType = DataRowType.SingleValue;
-      row2.LineType = DataRowType.SingleValue;
+      row1.RowSettings.Style = DrawingStyle.Solid;
+      row2.RowSettings.Style = DrawingStyle.Solid;
+      row3.RowSettings.Style = DrawingStyle.Dashed;
+
+      row4.RowSettings.Style = DrawingStyle.Solid;
+      row5.RowSettings.Style = DrawingStyle.Solid;
+      row6.RowSettings.Style = DrawingStyle.Dashed;
+
+      row1.RowSettings.LineType = DataRowType.SingleValue;
+      row2.RowSettings.LineType = DataRowType.SingleValue;
       row1.AddValue(12);
 
@@ -591,7 +591,7 @@
       row1.RowSettings.Color = Color.Red;
       row1.RowSettings.Thickness = 3;
-      row1.Style = DrawingStyle.Dashed;
-
-      row1.LineType = DataRowType.Points;
+      row1.RowSettings.Style = DrawingStyle.Dashed;
+
+      row1.RowSettings.LineType = DataRowType.Points;
       model.AddDataRow(row1);
 
Index: /trunk/sources/HeuristicLab.Visualization/3.2/DataRow.cs
===================================================================
--- /trunk/sources/HeuristicLab.Visualization/3.2/DataRow.cs	(revision 1971)
+++ /trunk/sources/HeuristicLab.Visualization/3.2/DataRow.cs	(revision 1972)
@@ -32,7 +32,7 @@
       this.RowSettings.Color = color;
       this.RowSettings.Thickness = thickness;
-      this.Style = style;
+      this.RowSettings.Style = style;
       this.dataRow = dataRow;
-      this.ShowMarkers = true;
+      this.RowSettings.ShowMarkers = true;
     }
 
@@ -41,6 +41,6 @@
       this.RowSettings.Color = color;
       this.RowSettings.Thickness = thickness;
-      this.Style = style;
-      this.ShowMarkers = showMarkers;
+      this.RowSettings.Style = style;
+      this.RowSettings.ShowMarkers = showMarkers;
       this.dataRow = dataRow;
     }
Index: /trunk/sources/HeuristicLab.Visualization/3.2/DataRowBase.cs
===================================================================
--- /trunk/sources/HeuristicLab.Visualization/3.2/DataRowBase.cs	(revision 1971)
+++ /trunk/sources/HeuristicLab.Visualization/3.2/DataRowBase.cs	(revision 1972)
@@ -6,23 +6,36 @@
     //private Color color = Color.Black;
     //private int thickness = 2;
-    private DrawingStyle style = DrawingStyle.Solid;
-    private DataRowType lineType = DataRowType.Normal;
+//    private DrawingStyle style = DrawingStyle.Solid;
+//    private DataRowType lineType = DataRowType.Normal;
     private YAxisDescriptor yAxis;
-    private bool showMarkers = true;
+//    private bool showMarkers = true;
 
-    private DataRowSettings rowSettings = new DataRowSettings();
+    private DataRowSettings rowSettings ;
 
     public DataRowSettings RowSettings {
       get { return rowSettings; }
-      set { rowSettings = value; }
+      set {
+        rowSettings.DataVisualSettingChanged -= value_DataVisualSettingChanged;
+        value.DataVisualSettingChanged += value_DataVisualSettingChanged;
+        rowSettings = value;
+      }
     }
 
-    public bool ShowMarkers {
-      get { return showMarkers; }
-      set {
-        showMarkers = value;
-        OnDataRowChanged(this);
-      }
-    }          
+    public DataRowBase() {
+      rowSettings = new DataRowSettings();
+      rowSettings.DataVisualSettingChanged += value_DataVisualSettingChanged;
+    }
+
+    void value_DataVisualSettingChanged(DataRowSettings row) {
+      OnDataRowChanged(this);
+    }
+
+//    public bool ShowMarkers {
+//      get { return showMarkers; }
+//      set {
+//        showMarkers = value;
+//        OnDataRowChanged(this);
+//      }
+//    }          
 
 //    public string Label {
@@ -50,19 +63,19 @@
 //    }
 
-    public DrawingStyle Style {
-      get { return style; }
-      set {
-        style = value;
-        OnDataRowChanged(this);
-      }
-    }
-
-    public DataRowType LineType {
-      get { return lineType; }
-      set {
-        lineType = value;
-        OnDataRowChanged(this);
-      }
-    }
+//    public DrawingStyle Style {
+//      get { return style; }
+//      set {
+//        style = value;
+//        OnDataRowChanged(this);
+//      }
+//    }
+//
+//    public DataRowType LineType {
+//      get { return lineType; }
+//      set {
+//        lineType = value;
+//        OnDataRowChanged(this);
+//      }
+//    }
 
     public YAxisDescriptor YAxis {
Index: /trunk/sources/HeuristicLab.Visualization/3.2/IDataRow.cs
===================================================================
--- /trunk/sources/HeuristicLab.Visualization/3.2/IDataRow.cs	(revision 1971)
+++ /trunk/sources/HeuristicLab.Visualization/3.2/IDataRow.cs	(revision 1972)
@@ -11,7 +11,7 @@
     //Color Color { get; set; }
     //int Thickness { get; set; }
-    DrawingStyle Style { get; set; }
-    DataRowType LineType { get; set; }
-    bool ShowMarkers { get; set; }
+//    DrawingStyle Style { get; set; }
+//    DataRowType LineType { get; set; }
+//    bool ShowMarkers { get; set; }
     DataRowSettings RowSettings { get; set; }
  
Index: /trunk/sources/HeuristicLab.Visualization/3.2/Options/DataRowSettings.cs
===================================================================
--- /trunk/sources/HeuristicLab.Visualization/3.2/Options/DataRowSettings.cs	(revision 1971)
+++ /trunk/sources/HeuristicLab.Visualization/3.2/Options/DataRowSettings.cs	(revision 1972)
@@ -4,4 +4,5 @@
   public class DataRowSettings {
     public event UpdateDataRowSettingsHandler OnUpdateDataRowSettings;
+    public event DataVisualSettingChangedHandler DataVisualSettingChanged;
 
     private string label;
@@ -36,25 +37,17 @@
     }
 
-//    public bool ShowMarkers {
-//      get { return showMarkers; }
-//      set {
-//        showMarkers = value;
-//        //OnDataRowChanged(this);
-//      }
-//    }
-
     public string Label {
       get { return label; }
       set {
         label = value;
-        //OnDataRowChanged(this);
+        OnDataVisualSettingChanged(this);
       }
     }
-
+    
     public Color Color {
       get { return color; }
       set {
         color = value;
-        //OnDataRowChanged(this);
+        OnDataVisualSettingChanged(this);
       }
     }
@@ -64,24 +57,40 @@
       set {
         thickness = value;
-        //OnDataRowChanged(this);
+        OnDataVisualSettingChanged(this);
       }
     }
 
-//    public DrawingStyle Style {
-//      get { return style; }
-//      set {
-//        style = value;
-//        //OnDataRowChanged(this);
-//      }
-//    }
-//
-//    public DataRowType LineType {
-//      get { return lineType; }
-//      set {
-//        lineType = value;
-//        //OnDataRowChanged(this);
-//      }
-//    }
+    public DrawingStyle Style {
+      get { return style; }
+      set {
+        style = value;
+        OnDataVisualSettingChanged(this);
+      }
+    }
+
+    public DataRowType LineType {
+      get { return lineType; }
+      set {
+        lineType = value;
+        OnDataVisualSettingChanged(this);
+      }
+    }
+
+    public bool ShowMarkers {
+      get { return showMarkers; }
+      set {
+        showMarkers = value;
+        OnDataVisualSettingChanged(this);
+      }
+    }
+    
+    protected void OnDataVisualSettingChanged(DataRowSettings row) {
+      if (DataVisualSettingChanged != null) {
+        DataVisualSettingChanged(this);
+      }
+    }
+
   }
   public delegate void UpdateDataRowSettingsHandler();
+  public delegate void DataVisualSettingChangedHandler(DataRowSettings row);
 }
Index: /trunk/sources/HeuristicLab.Visualization/3.2/Options/Options.cs
===================================================================
--- /trunk/sources/HeuristicLab.Visualization/3.2/Options/Options.cs	(revision 1971)
+++ /trunk/sources/HeuristicLab.Visualization/3.2/Options/Options.cs	(revision 1972)
@@ -29,7 +29,7 @@
         Color = row.RowSettings.Color;
         Thickness = row.RowSettings.Thickness;
-        Style = row.Style;
+        Style = row.RowSettings.Style;
         this.row = row;
-        this.ShowMarkers = row.ShowMarkers;
+        this.ShowMarkers = row.RowSettings.ShowMarkers;
       }
 
@@ -38,6 +38,6 @@
         row.RowSettings.Color = Color;
         row.RowSettings.Thickness = Thickness;
-        row.Style = Style;
-        row.ShowMarkers = this.ShowMarkers;
+        row.RowSettings.Style = Style;
+        row.RowSettings.ShowMarkers = this.ShowMarkers;
       }
     }
@@ -170,7 +170,7 @@
         LineThicknessCB.DataSource = GetThicknesses();
         LinestyleCB.DataSource = GetStyles();
-        LinestyleCB.SelectedItem = model.Rows[0].Style;
+        LinestyleCB.SelectedItem = model.Rows[0].RowSettings.Style;
         LineThicknessCB.SelectedItem = model.Rows[0].RowSettings.Thickness;
-        MarkercheckBox.Checked = model.Rows[0].ShowMarkers;
+        MarkercheckBox.Checked = model.Rows[0].RowSettings.ShowMarkers;
 
         LineSelectCB.DataSource = model.Rows;
@@ -216,7 +216,7 @@
           LinestyleCB.SelectedIndex = index;  */
         LineThicknessCB.SelectedItem = ((IDataRow)LineSelectCB.SelectedValue).RowSettings.Thickness;
-        LinestyleCB.SelectedItem = ((IDataRow)LineSelectCB.SelectedValue).Style;
+        LinestyleCB.SelectedItem = ((IDataRow)LineSelectCB.SelectedValue).RowSettings.Style;
         selectedLineColorSelection.Color = ((IDataRow)LineSelectCB.SelectedValue).RowSettings.Color;
-        MarkercheckBox.Checked = ((IDataRow)LineSelectCB.SelectedValue).ShowMarkers;
+        MarkercheckBox.Checked = ((IDataRow)LineSelectCB.SelectedValue).RowSettings.ShowMarkers;
       }
     }
@@ -229,5 +229,5 @@
     private void LinestyleCB_SelectedIndexChanged(object sender, EventArgs e) {
       if (LineSelectCB.SelectedValue != null) {
-        ((IDataRow)LineSelectCB.SelectedValue).Style = (DrawingStyle)LinestyleCB.SelectedItem;
+        ((IDataRow)LineSelectCB.SelectedValue).RowSettings.Style = (DrawingStyle)LinestyleCB.SelectedItem;
       }
     }
@@ -241,5 +241,5 @@
     private void MarkercheckBox_CheckedChanged(object sender, EventArgs e) {
       if (LineSelectCB.SelectedValue != null) {
-        ((IDataRow)LineSelectCB.SelectedValue).ShowMarkers = MarkercheckBox.Checked;
+        ((IDataRow)LineSelectCB.SelectedValue).RowSettings.ShowMarkers = MarkercheckBox.Checked;
       }
     }