Index: /trunk/sources/HeuristicLab.Hive.Server.ADODataAccess/3.2/ClientConfigAdapter.cs
===================================================================
--- /trunk/sources/HeuristicLab.Hive.Server.ADODataAccess/3.2/ClientConfigAdapter.cs	(revision 2002)
+++ /trunk/sources/HeuristicLab.Hive.Server.ADODataAccess/3.2/ClientConfigAdapter.cs	(revision 2002)
@@ -0,0 +1,52 @@
+﻿using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using HeuristicLab.DataAccess.ADOHelper;
+using HeuristicLab.Hive.Contracts.BusinessObjects;
+using HeuristicLab.Hive.Server.DataAccess;
+using HeuristicLab.Hive.Server.ADODataAccess.TableAdapterWrapper;
+
+namespace HeuristicLab.Hive.Server.ADODataAccess {
+  class ClientConfigAdapter :
+    DataAdapterBase<
+      dsHiveServerTableAdapters.ClientConfigTableAdapter,
+      ClientConfig,
+      dsHiveServer.ClientConfigRow>,
+    IClientConfigAdapter {
+    public ClientConfigAdapter(): 
+      base(new ClientConfigAdapterWrapper()) {
+    }
+
+    protected override dsHiveServer.ClientConfigRow 
+      ConvertObj(ClientConfig config, dsHiveServer.ClientConfigRow row) {
+      if (row != null && config != null) {
+        row.ClientConfigId = config.Id;
+        row.HeartBeatIntervall = config.HeartBeatIntervall;
+        row.UpDownTimeCalendar = config.UpDownTimeCalendar;
+
+        return row;
+      } else
+        return null;
+    }
+
+    protected override ClientConfig ConvertRow(dsHiveServer.ClientConfigRow row, ClientConfig config) {
+      if (config != null && row != null) {
+        config.Id = row.ClientConfigId;
+
+        if (!row.IsHeartBeatIntervallNull())
+          config.HeartBeatIntervall = row.HeartBeatIntervall;
+        else
+          config.HeartBeatIntervall = 0;
+
+        if (!row.IsUpDownTimeCalendarNull())
+          config.UpDownTimeCalendar = row.UpDownTimeCalendar;
+        else
+          config.UpDownTimeCalendar = null;
+
+        return config;
+      } else
+        return null;
+    }
+  }
+}
Index: /trunk/sources/HeuristicLab.Hive.Server.ADODataAccess/3.2/TableAdapterWrapper/ClientConfigAdapterWrapper.cs
===================================================================
--- /trunk/sources/HeuristicLab.Hive.Server.ADODataAccess/3.2/TableAdapterWrapper/ClientConfigAdapterWrapper.cs	(revision 2002)
+++ /trunk/sources/HeuristicLab.Hive.Server.ADODataAccess/3.2/TableAdapterWrapper/ClientConfigAdapterWrapper.cs	(revision 2002)
@@ -0,0 +1,50 @@
+﻿using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using HeuristicLab.Hive.Contracts.BusinessObjects;
+using HeuristicLab.DataAccess.ADOHelper;
+using System.Data.SqlClient;
+using System.Data.Common;
+
+namespace HeuristicLab.Hive.Server.ADODataAccess.TableAdapterWrapper {
+  class ClientConfigAdapterWrapper :
+    TableAdapterWrapperBase<
+        dsHiveServerTableAdapters.ClientConfigTableAdapter,
+    ClientConfig,
+    dsHiveServer.ClientConfigRow> {
+    public override void UpdateRow(dsHiveServer.ClientConfigRow row) {
+      TransactionalAdapter.Update(row);
+    }
+
+    public override dsHiveServer.ClientConfigRow
+      InsertNewRow(ClientConfig config) {
+      dsHiveServer.ClientConfigDataTable data =
+        new dsHiveServer.ClientConfigDataTable();
+
+      dsHiveServer.ClientConfigRow row = data.NewClientConfigRow();
+      row.ClientConfigId = config.Id;
+      data.AddClientConfigRow(row);
+
+      return row;
+    }
+
+    public override IEnumerable<dsHiveServer.ClientConfigRow>
+      FindById(Guid id) {
+      return TransactionalAdapter.GetDataById(id);
+    }
+
+    public override IEnumerable<dsHiveServer.ClientConfigRow>
+      FindAll() {
+      return TransactionalAdapter.GetData();
+    }
+
+    protected override void SetConnection(DbConnection connection) {
+      adapter.Connection = connection as SqlConnection;
+    }
+
+    protected override void SetTransaction(DbTransaction transaction) {
+      adapter.Transaction = transaction as SqlTransaction;
+    }
+  }
+}
Index: /trunk/sources/HeuristicLab.Hive.Server.DataAccess/3.2/IClientConfigAdapter.cs
===================================================================
--- /trunk/sources/HeuristicLab.Hive.Server.DataAccess/3.2/IClientConfigAdapter.cs	(revision 2002)
+++ /trunk/sources/HeuristicLab.Hive.Server.DataAccess/3.2/IClientConfigAdapter.cs	(revision 2002)
@@ -0,0 +1,30 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2008 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using HeuristicLab.Hive.Contracts.BusinessObjects;
+using HeuristicLab.DataAccess.Interfaces;
+
+namespace HeuristicLab.Hive.Server.DataAccess {
+  public interface IClientConfigAdapter: IDataAdapter<ClientConfig> {
+  }
+}