Index: trunk/sources/HeuristicLab.Hive.Client.Common/3.2/HeuristicLab.Hive.Client.Common-3.2.csproj
===================================================================
--- trunk/sources/HeuristicLab.Hive.Client.Common/3.2/HeuristicLab.Hive.Client.Common-3.2.csproj	(revision 2005)
+++ trunk/sources/HeuristicLab.Hive.Client.Common/3.2/HeuristicLab.Hive.Client.Common-3.2.csproj	(revision 2006)
@@ -67,4 +67,8 @@
   </PropertyGroup>
   <ItemGroup>
+    <Reference Include="Calendar.DayView, Version=1.0.0.0, Culture=neutral, PublicKeyToken=ba48961d6f65dcec, processorArchitecture=MSIL">
+      <SpecificVersion>False</SpecificVersion>
+      <HintPath>.\Calendar.DayView.dll</HintPath>
+    </Reference>
     <Reference Include="System" />
     <Reference Include="System.Core">
Index: trunk/sources/HeuristicLab.Hive.Client.Console/3.2/HeuristicLab.Hive.Client.Console-3.2.csproj
===================================================================
--- trunk/sources/HeuristicLab.Hive.Client.Console/3.2/HeuristicLab.Hive.Client.Console-3.2.csproj	(revision 2005)
+++ trunk/sources/HeuristicLab.Hive.Client.Console/3.2/HeuristicLab.Hive.Client.Console-3.2.csproj	(revision 2006)
@@ -68,8 +68,4 @@
   </PropertyGroup>
   <ItemGroup>
-    <Reference Include="Calendar.DayView, Version=1.0.0.0, Culture=neutral, PublicKeyToken=ba48961d6f65dcec, processorArchitecture=MSIL">
-      <SpecificVersion>False</SpecificVersion>
-      <HintPath>.\Calendar.DayView.dll</HintPath>
-    </Reference>
     <Reference Include="System" />
     <Reference Include="System.Core">
@@ -164,4 +160,8 @@
   </ItemGroup>
   <ItemGroup>
+    <ProjectReference Include="..\..\HeuristicLab.Hive.Client.Common\3.2\HeuristicLab.Hive.Client.Common-3.2.csproj">
+      <Project>{89F4BC52-C174-481E-9BD2-3814171020E8}</Project>
+      <Name>HeuristicLab.Hive.Client.Common-3.2</Name>
+    </ProjectReference>
     <ProjectReference Include="..\..\HeuristicLab.Hive.Contracts\3.2\HeuristicLab.Hive.Contracts-3.2.csproj">
       <Project>{134F93D7-E7C8-4ECD-9923-7F63259A60D8}</Project>
Index: trunk/sources/HeuristicLab.Hive.Client.Console/3.2/HiveClientConsole.Designer.cs
===================================================================
--- trunk/sources/HeuristicLab.Hive.Client.Console/3.2/HiveClientConsole.Designer.cs	(revision 2005)
+++ trunk/sources/HeuristicLab.Hive.Client.Console/3.2/HiveClientConsole.Designer.cs	(revision 2006)
@@ -46,5 +46,5 @@
     private void InitializeComponent() {
         this.components = new System.ComponentModel.Container();
-        Calendar.DrawTool drawTool2 = new Calendar.DrawTool();
+        Calendar.DrawTool drawTool1 = new Calendar.DrawTool();
         System.ComponentModel.ComponentResourceManager resources = new System.ComponentModel.ComponentResourceManager(typeof(HiveClientConsole));
         this.dvOnline = new Calendar.DayView();
@@ -96,4 +96,5 @@
         this.mcOnline = new System.Windows.Forms.MonthCalendar();
         this.ilEventLog = new System.Windows.Forms.ImageList(this.components);
+        this.btnSaveCal = new System.Windows.Forms.Button();
         this.tcClientConsole.SuspendLayout();
         this.tpConnection.SuspendLayout();
@@ -111,6 +112,6 @@
         // dvOnline
         // 
-        drawTool2.DayView = this.dvOnline;
-        this.dvOnline.ActiveTool = drawTool2;
+        drawTool1.DayView = this.dvOnline;
+        this.dvOnline.ActiveTool = drawTool1;
         this.dvOnline.AmPmDisplay = false;
         this.dvOnline.AppointmentDuration = Calendar.AppointmentSlotDuration.SixtyMinutes;
@@ -477,4 +478,5 @@
         // groupBox1
         // 
+        this.groupBox1.Controls.Add(this.btnSaveCal);
         this.groupBox1.Controls.Add(this.txttimeTo);
         this.groupBox1.Controls.Add(this.txttimeFrom);
@@ -532,5 +534,5 @@
         // 
         this.chbade.AutoSize = true;
-        this.chbade.Location = new System.Drawing.Point(72, 71);
+        this.chbade.Location = new System.Drawing.Point(135, 70);
         this.chbade.Name = "chbade";
         this.chbade.Size = new System.Drawing.Size(90, 17);
@@ -603,4 +605,14 @@
         this.ilEventLog.Images.SetKeyName(1, "Error.png");
         // 
+        // btnSaveCal
+        // 
+        this.btnSaveCal.Location = new System.Drawing.Point(8, 66);
+        this.btnSaveCal.Name = "btnSaveCal";
+        this.btnSaveCal.Size = new System.Drawing.Size(75, 23);
+        this.btnSaveCal.TabIndex = 41;
+        this.btnSaveCal.Text = "scal";
+        this.btnSaveCal.UseVisualStyleBackColor = true;
+        this.btnSaveCal.Click += new System.EventHandler(this.btnSaveCal_Click);
+        // 
         // HiveClientConsole
         // 
@@ -609,5 +621,4 @@
         this.BackColor = System.Drawing.SystemColors.Control;
         this.ClientSize = new System.Drawing.Size(853, 438);
-        this.ControlBox = false;
         this.Controls.Add(this.tcClientConsole);
         this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedSingle;
@@ -686,4 +697,5 @@
     private System.Windows.Forms.DateTimePicker txttimeFrom;
     private System.Windows.Forms.TextBox txtLog;
+    private System.Windows.Forms.Button btnSaveCal;
   }
 }
Index: trunk/sources/HeuristicLab.Hive.Client.Console/3.2/HiveClientConsole.cs
===================================================================
--- trunk/sources/HeuristicLab.Hive.Client.Console/3.2/HiveClientConsole.cs	(revision 2005)
+++ trunk/sources/HeuristicLab.Hive.Client.Console/3.2/HiveClientConsole.cs	(revision 2006)
@@ -32,4 +32,6 @@
 using ZedGraph;
 using HeuristicLab.Hive.Contracts;
+using System.Xml.Serialization;
+using System.IO;
 
 namespace HeuristicLab.Hive.Client.Console
@@ -58,5 +60,7 @@
     private ListViewColumnSorterDate lvwColumnSorter;
 
-    private List<Appointment> onlineTimes = new List<Appointment>();
+    [XmlArray("Appointments")]
+    [XmlArrayItem("Appointment",typeof(Appointment))]
+    public List<Appointment> onlineTimes = new List<Appointment>();
 
     public OnDialogClosedDelegate dialogClosedDelegate;
@@ -74,4 +78,16 @@
       InitCalender();
       InitLogFileReader();
+      //InitTestCalenderEntries();
+    }
+
+    private void InitTestCalenderEntries()
+    {
+        DateTime date = DateTime.Now;
+        while (date.Year == 2009)
+        {
+            
+            onlineTimes.Add(CreateAppointment(date.AddHours(1), date.AddHours(3), false));
+            date = date.AddDays(1);
+        }
     }
 
@@ -584,5 +600,29 @@
     }
 
+
+   private void SerializeCalender() {
+     
+       XmlSerializer s = new XmlSerializer(typeof(List<Appointment>));
+       TextWriter w = new StreamWriter(@"c:\temp\apptest.xml");
+       s.Serialize(w, onlineTimes);
+       w.Close();
+   }
+
+   private void DeSerializeCalender()
+   {
+       XmlSerializer s = new XmlSerializer(typeof(List<Appointment>));
+       TextReader r = new StreamReader(@"c:\temp\apptest.xml");
+       onlineTimes = (List<Appointment>)s.Deserialize(r);
+       onlineTimes.ForEach(a => a.BorderColor = Color.Red);
+       r.Close();
+
+   }
+
     #endregion
+
+   private void btnSaveCal_Click(object sender, EventArgs e)
+   {
+       DeSerializeCalender();
+   }
 
   }
Index: trunk/sources/HeuristicLab.Hive.Client.Console/3.2/HiveClientConsole.resx
===================================================================
--- trunk/sources/HeuristicLab.Hive.Client.Console/3.2/HiveClientConsole.resx	(revision 2005)
+++ trunk/sources/HeuristicLab.Hive.Client.Console/3.2/HiveClientConsole.resx	(revision 2006)
@@ -127,44 +127,44 @@
         ZW0uV2luZG93cy5Gb3Jtcy5JbWFnZUxpc3RTdHJlYW1lcgEAAAAERGF0YQcCAgAAAAkDAAAADwMAAABS
         CgAAAk1TRnQBSQFMAgEBAgEAAQQBAAEEAQABEAEAARABAAT/ASEBAAj/AUIBTQE2BwABNgMAASgDAAFA
-        AwABEAMAAQEBAAEgBgABECoAAUMCAQF0AWYCCQHxAyUB/wFiAgMB1AEgAgEBLCwAAUMCAQF0AWYCCQHx
-        AyUB/wFiAgMB1AEgAgEBLKQAAWACCgHyAZMBfwElAf8BvwGBASUB/wG9AYEBJQH/AboBgQElAf8BuAGB
-        ASUB/wG2AYEBJQH/AVkBQgElAf8BPQIBAWUcAAFgAgoB8gIlAaQB/wIlAdYB/wIlAdQB/wIlAdIB/wIl
-        AdAB/wIlAc4B/wIlAWAB/wE9AgEBZZgAAS8BKwElAf8BxwGBASUB/wHDAYEBJQH/AbEBgQElAf8BsQGB
-        ASUB/wGxAYEBJQH/AbEBgQElAf8BswGBASUB/wG2AYEBJQH/AbQBgQElAf8BZAIFAeQUAAIlATAB/wIl
-        AdwB/wIlAdkB/wIlAcoB/wIlAcoB/wIlAcoB/wIlAcoB/wIlAcsB/wIlAc4B/wIlAcwB/wFkAgUB5JAA
-        AyUB/wHLAYEBJQH/AbsBgQElAf8BtgGBASUB/wG2AYEBJQH/Ae4B3AHEBf8BvgGBAUIB/wG2AYEBJQH/
-        AbYBgQElAf8BtgGBASUB/wG0AYEBJQH/AUkCAgGGDAADJQH/AiUB4AH/AiUB0gH/AiUBzgH/AlIB1gH/
-        AiUBzgH/AiUBzgH/AiUBzgH/AigBzgH/AiUBzgH/AiUBzgH/AiUBzAH/AUkCAgGGiAABLAIBAUIB0AGG
-        ASUB/wHHAYEBJQH/AboBgQElAf8BugGBASUB/wG6AYEBJQH/AdABnAF2Bf8BugGBASUB/wG6AYEBJQH/
-        AboBgQElAf8BugGBASUB/wG2AYEBJQH/AXkBVAElAf8IAAEsAgEBQgIlAeQB/wIlAdwB/wIlAdIB/wKf
-        Ae0F/wJrAd4B/wIlAdIB/wL0Af0F/wIoAdIB/wIlAdIB/wIlAc4B/wIlAYEB/4gAAyUB/wHSAYkBJQH/
-        Ab8BgQElAf8BvwGBASUB/wG/AYEBJQH/Ab8BgQElAf8B0wGfAXYF/wG/AYEBJQH/Ab8BgQElAf8BvwGB
-        ASUB/wG/AYEBJQH/Ab4BgQElAf8BtgGBASUB/wE2AgEBVwQAAyUB/wIlAeUB/wIlAdYB/wIlAdYN/wL1
-        Af0J/wLiAfoB/wIlAdYB/wIlAdUB/wIlAc4B/wE2AgEBV4QAAW0BVQElAf8B1AGMASUB/wHEAYEBJQH/
-        AcQBgQElAf8BxAGBASUB/wHEAYEBJQH/AdcBpAF3Bf8BxAGBASUB/wHEAYEBJQH/AcQBgQElAf8BxAGB
-        ASUB/wHEAYEBJQH/AbgBgQElAf8BZQIHAewEAAIlAXMB/wIlAegB/wIlAdoB/wIlAdoB/wIlAdoR/wLi
-        AfoB/wIlAdoB/wIlAdoB/wIlAdoB/wIlAdAB/wFlAgcB7IQAAYEBagElAf8B1wGOASUB/wHJAYEBJQH/
-        AckBgQElAf8ByQGBASUB/wHJAYEBJQn/AckBgQElAf8ByQGBASUB/wHJAYEBJQH/AckBgQElAf8ByQGB
-        ASUB/wG6AYEBJQH/AyUB/wQAAiUBgQH/AiUB6QH/AiUB3gH/AiUB3gH/AiUB3gH/AvQB/Q3/AmsB5wH/
-        AiUB3gH/AiUB3gH/AiUB3gH/AiUB0gH/AyUB/4QAAX0BWwElAf8B2QGRASUB/wHOAYMBJQH/Ac4BgwEl
-        Af8BzgGDASUB/wHOAYMBJQH/Ac4BgwElAf8B1wGcAVYB/wHOAYMBJQH/Ac4BgwElAf8BzgGDASUB/wHO
-        AYMBJQH/Ac4BgwElAf8BvQGBASUB/wFVAhMB+QQAASUBKgF8Af8CJQHsAf8CJQHiAf8CJQHiAf8C9AH9
-        Ff8CawHqAf8CJQHiAf8CJQHiAf8CJQHUAf8BVQITAfmEAAEoASYBJQH/AdsBlAElAf8B0gGJASUB/wHS
-        AYkBJQH/AdIBiQElAf8B0gGJASUB/wHSAYkBJQH/AesBywGQAf8B0gGJASUB/wHSAYkBJQH/AdIBiQEl
-        Af8B0gGJASUB/wHEAYEBJQH/Ab8BgQElAf8BUQICAZsEAAIlASgB/wIlAe0B/wIlAeYB/wIlAeUB/wL9
-        Af4F/wLiAfwB/wIlAeUJ/wKBAfEB/wIlAeUB/wIlAdoB/wIlAdYB/wFRAgIBm4QAAVgCAgGyAd4BmAEl
-        Af8B2wGUASUB/wHXAY4BJQH/AdcBjgElAf8B1wGOASUB/wH7AfYB6wX/AdcBjgElAf8B1wGOASUB/wHX
-        AY4BJQH/AdYBjQElAf8BxAGBASUB/wGpAYEBJQH/CAABWAICAbIBJQEvAe8B/wIlAe0B/wIlAekB/wIl
-        AekB/wLhAfwB/wIlAekB/wIlAekB/wIlAekB/wKBAfMB/wIlAekB/wIlAegB/wIlAdoB/wElAS0BnQH/
-        jAABXwFEASUB/wHdAZcBJQH/AdsBlAElAf8B2wGUASUB/wHbAZQBJQH/AdsBlAElAf8B3AGXASsB/wHb
-        AZQBJQH/AdsBlAElAf8B1QGMASUB/wHJAYEBJQH/AdEBiAElAf8BLAIhAfwMAAIlAVkB/wIlAe8B/wIl
-        Ae0B/wIlAe0B/wIlAe0B/wIlAe0B/wIlAe0B/wIlAe0B/wIlAe0B/wIlAegB/wIlAd4B/wElATgB4gH/
-        ASwCIQH8jAABGQIBASEBkAF5ASUB/wHfAZkBJQH/AdsBlAElAf8B2QGRASUB/wHYAZABJQH/AdgBkAEl
-        Af8B0wGKASUB/wHQAYYBJQH/Ac4BgwElAf8B2gGSASUB/wEwASsBJQH/EAABGQIBASECJQGHAf8BJQEr
-        AfEB/wIlAe0B/wIlAewB/wIlAesB/wIlAesB/wIlAeYB/wIlAeQB/wIlAeIB/wElAUIB5gH/AiUBLwH/
-        lAABEgIBARYBSgE8ASUB/wHSAYkBJQH/AeIBnQElAf8B2QGRASUB/wHXAY4BJQH/AdUBjAElAf8B4QGb
-        ASUB/wHOAYQBJQH/AUUCJQH+GAABEgIBARYCJQFJAf8BJQErAdMB/wElATwB9AH/AiUB7AH/AiUB6QH/
-        ASUBJgHoAf8BJQFEAfAB/wIlAcwB/wFFAiUB/qAAAUYCAQF9AyUB/wF2AV0BJQH/AYEBdgElAf8BVwFI
-        ASUB/wFFAiUB/gEUAgEBGiQAAUYCAQF9AyUB/wIlAXkB/wIlAYEB/wIlAVkB/wFFAiUB/gEUAgEBGv8A
+        AwABEAMAAQEBAAEgBgABECoAAUMCAQF0AWYCCQHxAycB/wFiAgMB1AEgAgEBLCwAAUMCAQF0AWYCCQHx
+        AycB/wFiAgMB1AEgAgEBLKQAAWACCgHyAZMBgQEnAf8BvwGBAScB/wG9AYEBJwH/AboBgQEnAf8BuAGB
+        AScB/wG2AYEBJwH/AVsBRAEnAf8BPQIBAWUcAAFgAgoB8gInAaQB/wInAdYB/wInAdQB/wInAdIB/wIn
+        AdAB/wInAc4B/wInAWIB/wE9AgEBZZgAATEBLQEnAf8BxwGBAScB/wHDAYEBJwH/AbEBgQEnAf8BsQGB
+        AScB/wGxAYEBJwH/AbEBgQEnAf8BswGBAScB/wG2AYEBJwH/AbQBgQEnAf8BZAIFAeQUAAInATIB/wIn
+        AdwB/wInAdkB/wInAcoB/wInAcoB/wInAcoB/wInAcoB/wInAcsB/wInAc4B/wInAcwB/wFkAgUB5JAA
+        AycB/wHLAYEBJwH/AbsBgQEnAf8BtgGBAScB/wG2AYEBJwH/Ae4B3AHEBf8BvgGBAUQB/wG2AYEBJwH/
+        AbYBgQEnAf8BtgGBAScB/wG0AYEBJwH/AUkCAgGGDAADJwH/AicB4AH/AicB0gH/AicBzgH/AlQB1gH/
+        AicBzgH/AicBzgH/AicBzgH/AioBzgH/AicBzgH/AicBzgH/AicBzAH/AUkCAgGGiAABLAIBAUIB0AGG
+        AScB/wHHAYEBJwH/AboBgQEnAf8BugGBAScB/wG6AYEBJwH/AdABnAF4Bf8BugGBAScB/wG6AYEBJwH/
+        AboBgQEnAf8BugGBAScB/wG2AYEBJwH/AXsBVgEnAf8IAAEsAgEBQgInAeQB/wInAdwB/wInAdIB/wKf
+        Ae0F/wJtAd4B/wInAdIB/wL0Af0F/wIqAdIB/wInAdIB/wInAc4B/wInAYEB/4gAAycB/wHSAYkBJwH/
+        Ab8BgQEnAf8BvwGBAScB/wG/AYEBJwH/Ab8BgQEnAf8B0wGfAXgF/wG/AYEBJwH/Ab8BgQEnAf8BvwGB
+        AScB/wG/AYEBJwH/Ab4BgQEnAf8BtgGBAScB/wE2AgEBVwQAAycB/wInAeUB/wInAdYB/wInAdYN/wL1
+        Af0J/wLiAfoB/wInAdYB/wInAdUB/wInAc4B/wE2AgEBV4QAAW8BVwEnAf8B1AGMAScB/wHEAYEBJwH/
+        AcQBgQEnAf8BxAGBAScB/wHEAYEBJwH/AdcBpAF5Bf8BxAGBAScB/wHEAYEBJwH/AcQBgQEnAf8BxAGB
+        AScB/wHEAYEBJwH/AbgBgQEnAf8BZQIHAewEAAInAXUB/wInAegB/wInAdoB/wInAdoB/wInAdoR/wLi
+        AfoB/wInAdoB/wInAdoB/wInAdoB/wInAdAB/wFlAgcB7IQAAYEBbAEnAf8B1wGOAScB/wHJAYEBJwH/
+        AckBgQEnAf8ByQGBAScB/wHJAYEBJwn/AckBgQEnAf8ByQGBAScB/wHJAYEBJwH/AckBgQEnAf8ByQGB
+        AScB/wG6AYEBJwH/AycB/wQAAicBgQH/AicB6QH/AicB3gH/AicB3gH/AicB3gH/AvQB/Q3/Am0B5wH/
+        AicB3gH/AicB3gH/AicB3gH/AicB0gH/AycB/4QAAX8BXQEnAf8B2QGRAScB/wHOAYMBJwH/Ac4BgwEn
+        Af8BzgGDAScB/wHOAYMBJwH/Ac4BgwEnAf8B1wGcAVgB/wHOAYMBJwH/Ac4BgwEnAf8BzgGDAScB/wHO
+        AYMBJwH/Ac4BgwEnAf8BvQGBAScB/wFYAhMB+QQAAScBLAF+Af8CJwHsAf8CJwHiAf8CJwHiAf8C9AH9
+        Ff8CbQHqAf8CJwHiAf8CJwHiAf8CJwHUAf8BWAITAfmEAAEqASgBJwH/AdsBlAEnAf8B0gGJAScB/wHS
+        AYkBJwH/AdIBiQEnAf8B0gGJAScB/wHSAYkBJwH/AesBywGQAf8B0gGJAScB/wHSAYkBJwH/AdIBiQEn
+        Af8B0gGJAScB/wHEAYEBJwH/Ab8BgQEnAf8BUQICAZsEAAInASoB/wInAe0B/wInAeYB/wInAeUB/wL9
+        Af4F/wLiAfwB/wInAeUJ/wKBAfEB/wInAeUB/wInAdoB/wInAdYB/wFRAgIBm4QAAVgCAgGyAd4BmAEn
+        Af8B2wGUAScB/wHXAY4BJwH/AdcBjgEnAf8B1wGOAScB/wH7AfYB6wX/AdcBjgEnAf8B1wGOAScB/wHX
+        AY4BJwH/AdYBjQEnAf8BxAGBAScB/wGpAYEBJwH/CAABWAICAbIBJwExAe8B/wInAe0B/wInAekB/wIn
+        AekB/wLhAfwB/wInAekB/wInAekB/wInAekB/wKBAfMB/wInAekB/wInAegB/wInAdoB/wEnAS8BnQH/
+        jAABYQFGAScB/wHdAZcBJwH/AdsBlAEnAf8B2wGUAScB/wHbAZQBJwH/AdsBlAEnAf8B3AGXAS0B/wHb
+        AZQBJwH/AdsBlAEnAf8B1QGMAScB/wHJAYEBJwH/AdEBiAEnAf8BLAIhAfwMAAInAVsB/wInAe8B/wIn
+        Ae0B/wInAe0B/wInAe0B/wInAe0B/wInAe0B/wInAe0B/wInAe0B/wInAegB/wInAd4B/wEnAToB4gH/
+        ASwCIQH8jAABGQIBASEBkAF7AScB/wHfAZkBJwH/AdsBlAEnAf8B2QGRAScB/wHYAZABJwH/AdgBkAEn
+        Af8B0wGKAScB/wHQAYYBJwH/Ac4BgwEnAf8B2gGSAScB/wEyAS0BJwH/EAABGQIBASECJwGHAf8BJwEt
+        AfEB/wInAe0B/wInAewB/wInAesB/wInAesB/wInAeYB/wInAeQB/wInAeIB/wEnAUQB5gH/AicBMQH/
+        lAABEgIBARYBTAE+AScB/wHSAYkBJwH/AeIBnQEnAf8B2QGRAScB/wHXAY4BJwH/AdUBjAEnAf8B4QGb
+        AScB/wHOAYQBJwH/AUcCJwH+GAABEgIBARYCJwFLAf8BJwEtAdMB/wEnAT4B9AH/AicB7AH/AicB6QH/
+        AScBKAHoAf8BJwFGAfAB/wInAcwB/wFHAicB/qAAAUYCAQF9AycB/wF4AV8BJwH/AYEBeAEnAf8BWQFK
+        AScB/wFHAicB/gEUAgEBGiQAAUYCAQF9AycB/wInAXsB/wInAYEB/wInAVsB/wFHAicB/gEUAgEBGv8A
         kQABQgFNAT4HAAE+AwABKAMAAUADAAEQAwABAQEAAQEFAAGAFwAD/wEAAfwBHwH8AR8EAAHwAQcB8AEH
         BAAB4AEDAeABAwQAAcABAQHAAQEEAAGAAQEBgAEBBAABgAEAAYAFAAGAAQABgAUAAYABAAGABQABgAEA